VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7335
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8505
   LinkTopic       =   "Form1"
   ScaleHeight     =   7335
   ScaleWidth      =   8505
   StartUpPosition =   3  'Windows-Standard
   Begin VB.PictureBox Panel1 
      Align           =   1  'Oben ausrichten
      BorderStyle     =   0  'Kein
      Height          =   495
      Left            =   0
      ScaleHeight     =   495
      ScaleWidth      =   8505
      TabIndex        =   3
      Top             =   0
      Width           =   8505
      Begin VB.TextBox Text1 
         Alignment       =   1  'Rechts
         Height          =   315
         Index           =   3
         Left            =   6720
         TabIndex        =   11
         Text            =   "Text1"
         Top             =   120
         Width           =   975
      End
      Begin VB.TextBox Text1 
         Alignment       =   1  'Rechts
         Height          =   315
         Index           =   2
         Left            =   4800
         TabIndex        =   10
         Text            =   "Text1"
         Top             =   120
         Width           =   975
      End
      Begin VB.TextBox Text1 
         Alignment       =   1  'Rechts
         Height          =   315
         Index           =   1
         Left            =   2880
         TabIndex        =   9
         Text            =   "Text1"
         Top             =   120
         Width           =   975
      End
      Begin VB.TextBox Text1 
         Alignment       =   1  'Rechts
         Height          =   315
         Index           =   0
         Left            =   960
         TabIndex        =   5
         Text            =   "Text1"
         Top             =   120
         Width           =   975
      End
      Begin VB.Label Label4 
         Caption         =   "Label4"
         Height          =   255
         Left            =   6000
         TabIndex        =   8
         Top             =   120
         Width           =   735
      End
      Begin VB.Label Label3 
         Caption         =   "Label3"
         Height          =   255
         Left            =   4080
         TabIndex        =   7
         Top             =   120
         Width           =   735
      End
      Begin VB.Label Label2 
         Caption         =   "Label1"
         Height          =   255
         Left            =   2160
         TabIndex        =   6
         Top             =   120
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Label1"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   120
         Width           =   735
      End
   End
   Begin VB.PictureBox Picture3 
      BackColor       =   &H00FFFFFF&
      Height          =   1695
      Left            =   120
      ScaleHeight     =   1635
      ScaleWidth      =   3075
      TabIndex        =   2
      Top             =   3120
      Width           =   3135
   End
   Begin VB.PictureBox Picture2 
      BackColor       =   &H00FFFFFF&
      Height          =   1575
      Left            =   120
      ScaleHeight     =   1515
      ScaleWidth      =   3435
      TabIndex        =   1
      Top             =   1440
      Width           =   3495
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      Height          =   1095
      Left            =   120
      ScaleHeight     =   1035
      ScaleWidth      =   3675
      TabIndex        =   0
      Top             =   840
      Width           =   3735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private mSrcWav()   As Integer ' enthlt nur Raw-Audiodaten
Private mSrcSPS     As Long
Private mSrcSamples As Long
Private mSrcPeriods As Double

Private mSrcStep    As Double
Private mDstStep    As Double
Private t           As Double

Private mDstWav()   As Integer
Private mDstSPS     As Long
Private Const Pi    As Double = 3.14159265358979

Private Declare Function ArrPtr Lib "msvbvm60" _
                         Alias "VarPtr" ( _
                         ByRef pArr() As Any) As Long

Private Sub Form_Load()

    ' enthlt ein PictureBox (Panel1) das als Container
    ' fr 4 Label und 4 TextBoxen dient
    ' Align = 1 'Oben ausrichten

    Label1.Caption = "SrcSPS: "
    Label2.Caption = "DstSPS: "
    Label3.Caption = "Samples: "
    Label4.Caption = "Perioden: "

    ReDim mSrcWav(0)
    ReDim mDstWav(0)

    ' 44100 ': eine typische Samplerate
    ' 30000 ': eine willkrliche Samplerate
    mSrcSPS = 40000
    mDstSPS = 10000
    mSrcSamples = 100
    mSrcPeriods = 2#

    Call Initialize
    Call UpdateText1

End Sub

Private Sub Initialize()

    ' die Ausgangswave erstellen
    Call CreateSinWav(mSrcWav, mSrcSamples, mSrcPeriods)

    ' die Zielwave durch Resampling mit Linearer Interpolation erstellen
    Call ReSample(mDstWav, mDstSPS, mSrcWav, mSrcSPS)

End Sub

Private Sub UpdateText1()

    Text1(0).Text = CStr(mSrcSPS)
    Text1(1).Text = CStr(mDstSPS)
    Text1(2).Text = CStr(mSrcSamples)
    Text1(3).Text = CStr(mSrcPeriods)

End Sub

Private Sub CreateSinWav(wav() As Integer, ByVal Samples As Long, ByVal Periods As Double)

    ReDim wav(0 To Samples - 1)

    Dim i  As Long
    Dim A As Long
    Dim Phi As Double
    Dim PhiStep As Double
    Dim PhiMax As Double

    A = (2 ^ 15 - 1) * 0.9 ' , bzw. A = 30000

    PhiMax = Periods * 2 * Pi
    PhiStep = PhiMax / (Samples - 1)

    For Phi = 0 To PhiMax Step PhiStep
        wav(i) = CInt(A * Sin(Phi))
        i = i + 1
    Next

    ' Alternative Methode
    ' PhiStep = (Periods * 2 * Pi) / (samples - 1)
    '    For i = 0 To Samples - 1
    '        wav(i) = CInt(A * Sin(PhiStep * i))
    '    Next

End Sub

Public Sub ReSample(DstWav() As Integer, ByVal DstSps As Long, _
                    SrcWav() As Integer, ByVal SrcSPS As Long)

    Dim i     As Long
    Dim DstUB As Long
    Dim SrcUB As Long

    Dim j1 As Double
    Dim j2 As Double
    Dim j3 As Double

    Dim y1 As Double
    Dim y3 As Double

    mSrcStep = 1 / SrcSPS
    mDstStep = 1 / DstSps

    SrcUB = UBound(SrcWav)
    DstUB = ((SrcUB) * mSrcStep / mDstStep)

    ' Das Zielarray dimensionieren
    ReDim DstWav(0 To DstUB)

    ' den ersten Wert so zuweisen
    DstWav(0) = SrcWav(0)

    For i = 1 To DstUB - 1
        
        t = i * mDstStep  ' Zeit in der Zieldatei
        j2 = (t / mSrcStep) - 0
        j1 = (Int(j2))   ' die Stelle des niedrigeren Wertes
        j3 = j1 + 1      ' die Stelle des hheren Wertes

        ' den unteren Wert aus SrcWav rauslesen
        y1 = CDbl(SrcWav(CLng(j1)))

        ' den oberen Wert aus SrcWav rauslesen
        y3 = CDbl(SrcWav(CLng(j3)))
        DstWav(i) = (LinIPol(y1, y3, j1, j2, j3))
    Next

    DstWav(DstUB) = SrcWav(SrcUB)

End Sub

Private Function LinIPol(ByVal y1 As Double, _
                         ByVal y3 As Double, _
                         ByVal x1 As Double, _
                         ByVal x2 As Double, _
                         ByVal x3 As Double) As Double

    ' errechnet einen Wert y2 zu dem Wert x2 durch lineare Interpolation
    If (x3 - x1) = 0 Then
        LinIPol = y1
    Else
        LinIPol = y1 + (y3 - y1) / (x3 - x1) * (x2 - x1)
    End If

End Function

Private Sub Form_Resize()

    Dim L As Single, t As Single, W As Single, H As Single
    Dim brdr As Single
    Dim nPB As Long

    brdr = 8 * 15
    nPB = 3 ' Anzahl an PictureBoxen bereinander

    L = brdr: t = Panel1.Height + brdr
    W = Me.ScaleWidth - L - brdr
    H = (Me.ScaleHeight - t - brdr) / nPB - (2 * brdr / nPB)

    If W > 0 And H >= 0 Then Call Picture1.Move(L, t, W, H)

    t = t + H + brdr

    If W > 0 And H >= 0 Then Call Picture2.Move(L, t, W, H)

    t = t + H + brdr

    If W > 0 And H >= 0 Then Call Picture3.Move(L, t, W, H)

End Sub

Private Sub Picture1_Paint()

    Call Picture1.Cls

    If ArrPtr(mSrcWav) <> 0 Then Call DrawWav(mSrcWav, mSrcStep, Picture1)

End Sub

Private Sub Picture2_Paint()

    Call Picture2.Cls

    If ArrPtr(mDstWav) <> 0 Then Call DrawWav(mDstWav, mDstStep, Picture2)

End Sub

Private Sub Picture3_Paint()

    Call Picture3.Cls
    Picture3.ForeColor = 0
    If ArrPtr(mSrcWav) <> 0 Then Call DrawWav(mSrcWav, mSrcStep, Picture3)
    Picture3.ForeColor = vbRed
    If ArrPtr(mDstWav) <> 0 Then Call DrawWav(mDstWav, mDstStep, Picture3)

End Sub

Private Sub DrawWav(wav() As Integer, tstep As Double, aPB As PictureBox)

    Dim x1 As Long, y1 As Long
    Dim x2 As Long, y2 As Long
    Dim stepX As Double, stepY As Double
    Dim i As Long, wi As Integer
    Dim brdr As Single
    Dim tMax As Double
    Dim xfact As Double
    
    brdr = 8 * 15
    y1 = aPB.ScaleHeight / 2
    
    tMax = UBound(mSrcWav) / mSrcSPS
    
    xfact = (aPB.ScaleWidth - 2 * brdr) / tMax
    stepY = (aPB.ScaleHeight - brdr) / 65535

    For i = 0 To UBound(wav)
        wi = -wav(i)
        t = i * tstep
        x2 = brdr + t * xfact
        y2 = stepY * wi + aPB.ScaleHeight \ 2
        x1 = x2
        aPB.Line (x1, y1)-(x2, y2)
    Next

End Sub

Private Sub Text1_KeyDown(Index As Integer, KeyCode As Integer, Shift As Integer)

    Dim dblVal As Double

    Select Case KeyCode
    Case vbKeyPageDown, vbKeyPageUp, vbKeyReturn
    
        If IsNumeric(Text1(Index).Text) Then
            dblVal = CDbl(Text1(Index).Text)
        Else

            Exit Sub

        End If

        Select Case KeyCode
        Case vbKeyPageUp
            dblVal = dblVal + 1
        Case vbKeyPageDown
            dblVal = dblVal - 1
        Case Else
        
        End Select

        Select Case Index

        Case 0: mSrcSPS = CLng(dblVal)
        Case 1: mDstSPS = CLng(dblVal)
        Case 2: mSrcSamples = CLng(dblVal)
        Case 3: mSrcPeriods = dblVal

        End Select

        Call UpdateText1
        Call Initialize

        Picture1.Refresh
        Picture2.Refresh
        Picture3.Refresh
   
        
    End Select

End Sub
